/*

IFT1169 - Gestion de la mémoire - Exemple 09 -

09-décembre	- 2017 v1.01	M.Lokbani - GCC 7.2 avec -std=c++17
15-septembre	- 2016 v1.00	M.Lokbani - GCC 6.1.1 avec -std=c++11


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Duree d'une vie dynamique
        
    Voir notes de cours, 5.2
    
*/

#include <iostream>
using namespace std;

class Test {
public:
	Test(){ cout << "consructeur de l'objet:" << this << endl;}
	~Test() { cout << "destructeur de l'objet:" << this << endl;}
};

int main() {

	Test *ptr0 = new Test;
	Test *ptr1 = new Test;

	delete ptr0;
	delete ptr1;
	
	
	return 0;

}



/*
	// La mémoire a ete libere

	>./09_mem
		consructeur de l'objet:0x1721c20
		consructeur de l'objet:0x1722c50
		destructeur de l'objet:0x1721c20
		destructeur de l'objet:0x1722c50
	>Exit code: 0

*/