/*

IFT1169 - Gestion de la mémoire - Exemple 10 -

09-décembre	- 2017 v1.01	M.Lokbani - GCC 7.2 avec -std=c++17
15-septembre	- 2016 v1.00	M.Lokbani - GCC 6.1.1 avec -std=c++11


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Duree d'une vie dynamique
        
    Voir notes de cours, 5.3
    
*/

#include <iostream>
using namespace std;

class Test {
public:
	Test(){ cout << "consructeur de l'objet:" << this << endl;}
	~Test() { cout << "destructeur de l'objet:" << this << endl;}
};


int main() {

	int maxptr = 1;
	
	Test *ptr;
	
	ptr = new Test[maxptr];
	
	delete [] ptr;

	Test** unptr;
	
	unptr = new Test*[maxptr];
	
	for (int i = 0 ; i < maxptr; i++)
		unptr[i] = new Test [2];
	
	for (int i = 0 ; i < maxptr; i++)
		delete [] unptr[i];
	
	delete [] unptr;
	
	return 0;

}


/*

	>./10_mem
		consructeur de l'objet:0x223ec28
		destructeur de l'objet:0x223ec28
		consructeur de l'objet:0x223fc58
		consructeur de l'objet:0x223fc59
		destructeur de l'objet:0x223fc59
		destructeur de l'objet:0x223fc58
	>Exit code: 0

*/

