/*

IFT1169 - Gestion de la mémoire - Exemple 14 -

09-décembre	- 2017 v1.03	M.Lokbani - GCC 7.2 avec -std=c++17
09-mars			- 2015 v1.02	M.Lokbani - GCC 4.9.2  avec -std=c++11
09-novembre	- 2013 v1.01	M.Lokbani - GCC 4.8.1  avec -std=c++11
18-novembre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Les questions de placement - version longue! - 
        
    Voir notes de cours, 5.3:
    
    Ici on utilise un opérateur new classique.
    
*/

#include <iostream>
#include <ctime>

using namespace std;

class Test {};

int main() {
    
    clock_t start, finish;
    start = clock();
    for( long i = 0; i < 10000; ++i) {
        for ( long j = 0; j < 10000; ++j) {
            Test *dp = new Test();
            // ...
            delete dp;
        }
    }
    finish = clock();
    cout << "Time : "
        << ((double)(finish - start))/CLOCKS_PER_SEC << endl;
    
    return 0;
}

/*
	Le résultat est fonction de la puissance de votre machine

	>07mem
		Time : 23.938
	>Exit code: 0

*/
