/*

IFT1169 - Gestion de la mémoire - Exemple 18 -

09-décembre	- 2017 v1.03	M.Lokbani - GCC 7.2 avec -std=c++17
09-mars			- 2015 v1.02	M.Lokbani - GCC 4.9.2  avec -std=c++11
16-novembre	- 2013 v1.01	M.Lokbani - GCC 4.8.1  avec -std=c++11
18-novembre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Surdéfinition de l'opérateur new au niveau de la classe
        
    Voir notes de cours, 5.5:
    
*/

#include <iostream>

using namespace std;

class A {
public:
	void* operator new(size_t a,int z){
		cout << "a: " << a << " ; z: " << z << endl;
		return new char[a];
	}
};

int main() {
	A *ptr = new(5) A();
	cout << "ptr: " << ptr << endl;
	cout << "Un second test ...." << endl;
	A *btr = ::new A();
	cout << "btr: " << btr << endl;

	return 0;
}


/*

	>11mem
		a: 1 ; z: 5
		ptr: 0x665590
		Un second test ....
		btr: 0x6655b0
	>Exit code: 0

*/