/*

IFT1169 - Gestion de la mémoire - Exemple 19 -

09-mars			- 2015 v1.03	M.Lokbani - GCC 4.9.2  avec -std=c++11
16-novembre	- 2013 v1.01	M.Lokbani - GCC 4.8.1  avec -std=c++11
18-novembre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Surdéfinition des opérateurs new et delete au niveau de la classe et à un niveau global
        
    Voir notes de cours, 5.5:
    
*/

#include <iostream>

using namespace std;

int flag = 0;

//typedef unsigned int size_t;

void operator delete(void* p, int i){
	cout << "AAA" << endl;
	flag = 1;
}

void* operator new(size_t s, int i){
	cout << "ai" << endl;
	return new char[s];
}

class A {
public:
	A() {
		throw -37;
	}
	void operator delete(void* p, int i){
		cout << "ici" << endl;
		::delete reinterpret_cast<A *>(p);
		flag = 5;
	}
	void* operator new(size_t s, int i){
		cout << i << endl;
		return ::new char[s];
	}
};

int main(){
	try {
		A* p = new (1234) A;
		// On fait quelque chose avec p pour éviter l'averstissement ...
		cout << "taille de p: " << sizeof(p) << endl;
	}
	catch (int i) {
	}
	cout << "flag:"<< flag << endl;

	return 0;
}


/*

	>12mem
		1234
		ici
		flag:5
	>Exit code: 0

*/