/*

IFT1169 - Gestion de la mémoire - Exemple 01 -

09-décembre	- 2017 v1.04	M.Lokbani - GCC 7.2 avec -std=c++17
14-septembre	- 2016 v1.03	M.Lokbani - GCC 6.1.1 avec -std=c++11
09-mars			- 2015 v1.02	M.Lokbani - GCC 4.9.2  avec -std=c++11
09-novembre	- 2013 v1.01	M.Lokbani - GCC 4.8.1  avec -std=c++11
18-novembre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
-------------

    Gestion de la mémoire
    
	Cet exemple décrit l'utilisation des variables globales publiques
	et les variables globales privées.

	section 2.5
	
	L'exemple est réparti sur 2 fichiers:

	01mem.cpp
	01mem_main.cpp <=== contient le main
    
*/

#include <iostream>

using namespace std;

extern int tab[10];
extern int calcul(int,int);
static int i, j;

static int fonc() {
	return 5;
}
int main() {
	i=j=3;
	fonc();
	cout << calcul(i,j) << endl;
	cout << tab[0] << ";" << tab[1] << endl;
	return 0;
}

/*

    >01mem
	18
	3;3

    >Exit code: 0

*/
