/*

IFT1169 - Gestion de la mémoire - Exemple 06 -

09-décembre	- 2017 v1.01	M.Lokbani - GCC 7.2 avec -std=c++17
14-septembre	- 2016 v1.00	M.Lokbani - GCC 6.1.1 avec -std=c++11


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Duree de vie statique
        
    Voir notes de cours, 4.3:
    
*/

#include <iostream>
using namespace std;

static int x = 10; // x est une variable globale

void f(){
	
	static int j = 20; // j est une variable locale définie dans f
	
	cout << "j: " << j++ << endl; // j reutilisable pour chaque appel de f
	
	cout << "x_dans_f:" << x << endl; // x est accessible, vu qu'elle est globale

	return;
}

int main() {

	f(); // 1er appel, j est initialise a 20
	
	cout << "x_dans_main: " << x << endl; // x est accessible, vu qu'elle est globale, mais pas j

	f(); // 2e appel, j vaut maintenant 21
	
	
	return 0;

}



/*

	>./06_mem
		j: 20
		x_dans_f:10
		x_dans_main: 10
		j: 21
		x_dans_f:10
	>Exit code: 0

*/