/*

IFT1169 - Gestion de la mémoire - Exemple 07 -

09-décembre	- 2017 v1.01	M.Lokbani - GCC 7.2 avec -std=c++17
15-septembre	- 2016 v1.00	M.Lokbani - GCC 6.1.1 avec -std=c++11


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Duree d'une vie dynamique
        
    Voir notes de cours, 5
    
*/

#include <iostream>
using namespace std;

int* allocation(int taille){
	
	int* p = new int[taille];
	
	for (int i = 0; i < taille ; i++)
		p[i] = i;
	
	for (int i = 0; i < taille ; i++)
		cout << "p[" << i << "]=" << p[i] << endl;
		
	return p;
}

int main() {

	int *ptr;
	int max = 5;
	
	ptr = allocation(max);
	
	cout << "*ptr: "  << *ptr << endl;
	
	delete [] ptr;
	
	return 0;

}



/*
	>./07_mem
		p[0]=0
		p[1]=1
		p[2]=2
		p[3]=3
		p[4]=4
		*ptr: 0
	>Exit code: 0

*/